<template>
  <div>
    <v-toolbar flat>
      <v-toolbar-title v-if="!$vuetify.breakpoint.mobile" class="primary--text"
        >My Appointments</v-toolbar-title
      >
      <v-spacer v-if="!$vuetify.breakpoint.mobile" />
      <v-text-field
        v-model="search"
        filled
        label="search appointments"
        rounded
        dense
        single-line
        prepend-inner-icon="mdi-magnify"
        max-height="40px"
        hide-details
      />
    </v-toolbar>
    <v-data-table
      style="border-radius:16px;"
      :items="filteredAppointments"
      :loading="loading"
      :headers="headers"
      :items-per-page="5"
      :loading-text="'Getting Appointments'"
    >
      <template v-slot:item.status="{ item }">
        <v-chip
          color="teal"
          dark
          small
          v-if="$date().isBefore(item.fields.appointment_date)"
          >upcoming</v-chip
        >
        <v-chip color="red" dark small v-else>inactive</v-chip>
      </template>
      <template v-slot:item.fields.appointment_date="{ item }">
        {{
          $date(item.fields.appointment_date).format("ddd, MMM D, YYYY h:mm A")
        }}
      </template>
      <template slot="items" slot-scope="props">
        <tr>
          <td>{{ props.item.fields.appointment_postcode }}</td>
          <td>{{ props.item.fields.contact_phone }}</td>
          <td>{{ props.item.fields.contact_email }}</td>
        </tr>
      </template>
      <template v-slot:item.name="{ item }">
        <span v-for="(n, index) in item.fields.contact_name" :key="'d' + n">
          {{ n }} {{ item.fields.contact_surname[index] }}
          <span v-if="index < item.fields.contact_name.length - 1">,</span>
        </span>
      </template>
      <template v-slot:item.action="{ item }">
        <v-btn
          v-if="$date().isBefore(item.fields.appointment_date)"
          small
          @click="editapp(item)"
          fab
          icon
          primary
          ><v-icon color="primary">mdi-circle-edit-outline</v-icon></v-btn
        >
      </template>
    </v-data-table>
  </div>
</template>
<script>
export default {
  name: "appointments",
  components: {},
  data: () => ({
    appointments: [],
    search: "",
    loading: true,
    headers: [
      { text: "Status", value: "status" },
      {
        text: "Appointment Date",
        value: "fields.appointment_date",
        sortable: true,
      },
      { text: "Appointment Postcode", value: "fields.appointment_postcode" },
      { text: "Contact Phone", value: "fields.contact_phone" },
      { text: "Contact Email", value: "fields.contact_email" },
      { text: "Name", value: "name" },
      { text: "Edit", value: "action" },
    ],
  }),
  async mounted() {
    this.appointments = await this.$appointment.getAppointmentsByAgent(
      this.$root.selectedAgent.fields.agent_id
    );
    this.loading = false;
  },
  methods: {
    editapp(id) {
      console.log("editing ", id.fields.appointment_id);
    },
  },
  computed: {
    filteredAppointments() {
      return this.appointments.filter(
        (item) =>
          !this.search ||
          item.fields.appointment_date
            .toLowerCase()
            .match(this.search.toLowerCase()) ||
          item.fields.appointment_postcode
            .toLowerCase()
            .match(this.search.toLowerCase()) ||
          item.fields.contact_phone
            .join()
            .toLowerCase()
            .match(this.search.toLowerCase()) ||
          item.fields.contact_email
            .join()
            .toLowerCase()
            .match(this.search.toLowerCase()) ||
          item.fields.contact_name
            .join()
            .toLowerCase()
            .match(this.search.toLowerCase()) ||
          item.fields.contact_surname
            .join()
            .toLowerCase()
            .match(this.search.toLowerCase())
      );
    },
  },
};
</script>
